## ngcp-ngcpcfg 14.0.1.1+0~mr14.0.1.1

=== Makefile ===
# for syntax checks
BASH_SCRIPTS = \
	scripts/* \
	functions/* \
	etc/ngcp-ngcpcfg/ngcpcfg.cfg \
	sbin/ngcpcfg
PERL_SCRIPTS = \
	lib/NGCP/Template.pm \
	helper/del-value \
	helper/set-value \
	helper/sort-yml \
	helper/sync-db \
	helper/tt2-process \
	helper/validate-yml helper/fileformat_version \
	sbin/ngcp-instances-validator \
	sbin/ngcp-network \
	sbin/ngcp-network-validator \
	sbin/ngcp-sync-db-creds \
	sbin/ngcp-sync-db-grants \
	# EOL
YAML_SCHEMAS = \
	schemas/instances.yml \
	schemas/sites.yml \
	# EOL
RESULTS ?= results

all: docs

docs: man

man:
	asciidoctor -d manpage -b manpage docs/ngcpcfg.txt
	pod2man --section=8 sbin/ngcp-network > docs/ngcp-network.8
	pod2man --section=8 sbin/ngcp-network-validator > docs/ngcp-network-validator.8
	pod2man --section=8 sbin/ngcp-sync-db-creds > docs/ngcp-sync-db-creds.8
	pod2man --section=8 sbin/ngcp-sync-db-grants > docs/ngcp-sync-db-grants.8
	pod2man --section=3pm lib/NGCP/Template.pm > docs/NGCP::Template.3pm
	pod2man --section=3pm lib/NGCP/Template/Object.pm > docs/NGCP::Template::Object.3pm
	pod2man --section=3pm lib/NGCP/Template/Plugin/Utils.pm > docs/NGCP::Template::Plugin::Utils.3pm

clean:
	rm -f docs/*.8
	rm -f docs/*.3pm
	rm -rf t/__pycache__ t/fixtures/__pycache__/ t/*.pyc

dist-clean: clean
	rm -rf results

# check for syntax errors
syntaxcheck: shellcheck perlcheck yamlcheck

shellcheck:
	@echo -n "Checking for shell syntax errors"; \
	for SCRIPT in $(BASH_SCRIPTS); do \
		test -r $${SCRIPT} || continue ; \
		bash -n $${SCRIPT} || exit ; \
		echo -n "."; \
	done; \
	echo " done."; \

perlcheck:
	@echo "Checking for perl syntax errors:"; \
	for SCRIPT in $(PERL_SCRIPTS); do \
		test -r $${SCRIPT} || continue ; \
		perl -CSD -Ilib -w -c $${SCRIPT} || exit ; \
	done; \
	echo "-> perl check done."; \

yamlcheck:
	@echo "Checking for yaml syntax errors:"; \
	for YAML in $(YAML_SCHEMAS); do \
		test -r $${YAML} || continue ; \
		perl -MYAML::XS -E "YAML::XS::LoadFile('$${YAML}')" || exit ; \
	done; \
	echo "-> yaml check done."; \
	:

test:
	mkdir -p $(RESULTS)
	cd t ; py.test-3 --junit-xml=$(RESULTS)/pytest.xml -vv -l
# EOF

=== testsuite/Makefile ===
RESULTS ?= results

all: test

test:
	mkdir -p $(RESULTS)
	prove -v -I../lib . >$(RESULTS)/perl-modules.tap
	bash ./ngcp-network > $(RESULTS)/ngcp-network.tap

clean:
	rm -rf testfiles

dist-clean: clean
	rm -rf $(RESULTS)

=== debian/changelog ===
ngcp-ngcpcfg (14.0.1.1+0~mr14.0.1.1) unstable; urgency=medium

  [ Guillem Jover ]
  * [c211141] MT#60683 patch: Remove temporary import file

 -- Sipwise Jenkins Builder <jenkins@sipwise.com>  Tue, 09 Dec 2025 15:33:17 +0100

ngcp-ngcpcfg (14.0.1.0+0~mr14.0.1.0) unstable; urgency=medium

  [ Rene Krenn ]
  * [e191490] MT#63530 tolerate duplicate cdr tag data

 -- Sipwise Jenkins Builder <jenkins@sipwise.com>  Mon, 24 Nov 2025 16:57:16 +0100

ngcp-ngcpcfg (14.0.0.0+0~mr14.0.0.0) unstable; urgency=medium

  [ Guillem Jover ]
  * [39bfbf5] MT#62899 Update packaging for Debian trixie
  * [183e809] MT#56004 functions: Add a fallback value for NGCPCFG_PID
  * [fb385c9] MT#63522 patch: Add multi-site support

  [ Jose Su ]
  * [1cde0d2] MT#63242 Fix typo in restore_permissions

  [ Richard Fuchs ]
  * [04ccd56] MT#58458 make python checker happy
  * [26de469] MT#58458 tests: use separate state dir
  * [b765ca3] MT#58458 tests: remove duplicate .git extract
  * [eec0b4d] MT#58458 skip etckeeper during tests
  * [daf2351] MT#58458 don't touch systemd during tests
  * [76cb566] MT#58458 don't touch systemd during dry run
  * [f22aff2] MT#58458 skip DB sync during dry run
  * [e69c8d8] MT#58458 skip commit actions during dry run
  * [01ceb67] MT#58458 use mapfile for reading git status
  * [786bf64] MT#58458 tolerate non existent directory
  * [a53c7a1] MT#58458 support full --dry-run

  [ Marco Capetta ]
  * [04e6f0e] MT#63514 Add sites support to get_all_ips_for_host script

 -- Sipwise Jenkins Builder <jenkins@sipwise.com>  Mon, 08 Sep 2025 11:45:48 +0200

ngcp-ngcpcfg (13.5.0.0+0~mr13.5.0.0) unstable; urgency=medium

  [ Guillem Jover ]
  * [3c87cea] MT#62763 Fix shellcheck issues
  * [6220059] MT#62763 tests: Specify signals by name to trap

 -- Sipwise Jenkins Builder <jenkins@sipwise.com>  Fri, 20 Jun 2025 10:44:46 +0200

ngcp-ngcpcfg (13.4.0.0+0~mr13.4.0.0) unstable; urgency=medium

  [ Richard Fuchs ]
  * [b5b92ca] MT#62053 add "objects" output format for RTP intfs
  * [2b40e7b] MT#62053 add support for RTP port ranges
  * [ee99a44] MT#62053 fix spacing

  [ Guillem Jover ]
  * [67564ac] MT#62325 Remove support for Debian bullseye release and older
  * [a09d8f4] MT#62508 services: Remove any systemd broken service symlinks

 -- Sipwise Jenkins Builder <jenkins@sipwise.com>  Thu, 10 Apr 2025 08:29:11 +0200

ngcp-ngcpcfg (13.3.0.0+0~mr13.3.0.0) unstable; urgency=medium

  [ Michael Prokop ]
  * [bd89e3f] MT#61451 GH: raise workflow actions to v4

 -- Sipwise Jenkins Builder <jenkins@sipwise.com>  Tue, 28 Jan 2025 15:15:50 +0100

ngcp-ngcpcfg (13.2.0.0+0~mr13.2.0.0) unstable; urgency=medium

  [ Guillem Jover ]
  * [ae2d6e6] MT#61052 NGCP::Template::Plugin::Utils: Do not generate bogus YAML on empty string
  * [4371e41] MT#61459 Do not use Perl indirect object syntax
  * [03f4cda] MT#61568 Update gitignore entries
  * [3b5491a] MT#61568 debian: Switch to Rules-Requires-Root no

 -- Sipwise Jenkins Builder <jenkins@sipwise.com>  Mon, 09 Dec 2024 11:28:07 +0100

ngcp-ngcpcfg (13.1.0.0+0~mr13.1.0.0) unstable; urgency=medium

  [ Guillem Jover ]
  * [125ab4c] MT#60611 helper/del-value: Delete misplaced APPEND handling
  * [d59b6c7] MT#60917 NGCP::Template::Object: Do not use sort on return

  [ Michael Prokop ]
  * [eb1cd98] MT#60865 Fix shellcheck script issues
  * [0bcfc56] MT#60815 lib/set_debian_info: support Debian/trixie

  [ Rene Krenn ]
  * [fda5db9] MT#61052 support rendering yaml

 -- Sipwise Jenkins Builder <jenkins@sipwise.com>  Tue, 01 Oct 2024 10:01:08 +0200

ngcp-ngcpcfg (13.0.0.0+0~mr13.0.0.0) unstable; urgency=medium

  [ Kirill Solomko ]
  * [ec89a60] MT#60508 sync-grants warn on non-existing function/procedure

 -- Sipwise Jenkins Builder <jenkins@sipwise.com>  Sun, 28 Jul 2024 12:03:56 +0200

ngcp-ngcpcfg (12.5.0.0+0~mr12.5.0.0) unstable; urgency=medium

  [ Kirill Solomko ]
  * [04243d3] MT#59588 scripts/commit: source /etc/ngcp-roles for SPCE cases

  [ Guillem Jover ]
  * [c7447e7] MT#59859 Discontinue Rainbow platform merging into NGCP

 -- Sipwise Jenkins Builder <jenkins@sipwise.com>  Wed, 22 May 2024 14:32:39 +0200

ngcp-ngcpcfg (12.4.0.0+0~mr12.4.0.0) unstable; urgency=medium

  [ Guillem Jover ]
  * [a58e66b] MT#59308 commit: Do not include the date in the commit message
  * [d207a67] MT#59308 commit: Include reason in «ngcpcfg apply» commit messages
  * [367bbeb] MT#45670 NGCP::Template::Object: Add new get_hosts() method
  * [090653e] MT#58014 decrypt: Source logs instead of open-coding its contents
  * [6e5628d] MT#58014 encrypt, decrypt: Clarify cryptographic terms
  * [c4f6293] MT#58014 encrypt, decrypt: Do not use an intermediate unencrypted tarfile
  * [5d1b3dc] MT#58014 Refactor OpenPGP functions into a new functions file
  * [127e6a4] MT#58014 Replace GnuPG usage with Stateless OpenPGP CLI

  [ Michael Prokop ]
  * [12f91d4] MT#59492 Use reserved IPs following RFC5737

  [ Kirill Solomko ]
  * [52605d6] MT#59588 scripts/commit add grants/creds sync support for 3308

 -- Sipwise Jenkins Builder <jenkins@sipwise.com>  Fri, 15 Mar 2024 08:49:21 +0100

ngcp-ngcpcfg (12.3.0.0+0~mr12.3.0.0) unstable; urgency=medium

  * New release.

 -- Sipwise Jenkins Builder <jenkins@sipwise.com>  Mon, 15 Jan 2024 14:48:13 +0100

ngcp-ngcpcfg (12.2.0.0+0~mr12.2.0.0) unstable; urgency=medium

  [ Kirill Solomko ]
  * [0f8ad35] MT#58352 helper/sync-db add lb nodes outbound_socket support
  * [9d7fdb3] MT#58352 lb_and_extra_sockets_sync() fix undef extra_socket
  * [dbd7bb3] MT#58696 sync-db auto lb outbound sockets only sip_ext

  [ Guillem Jover ]
  * [02055b8] MT#58014 encrypt: Avoid remove leading / messages from tar

 -- Sipwise Jenkins Builder <jenkins@sipwise.com>  Wed, 29 Nov 2023 13:37:57 +0100

ngcp-ngcpcfg (12.1.0.0+0~mr12.1.0.0) unstable; urgency=medium

  [ Michael Prokop ]
  * [def4d75] TT#124273 github actions: replace bullseye with bookworm

  [ Guillem Jover ]
  * [670334b] MT#58356 Update packaging for bookworm



=== debian/control ===
Source: ngcp-ngcpcfg
Section: admin
Priority: optional
Maintainer: Sipwise Development Team <support@sipwise.com>
Homepage: https://www.sipwise.com/
Standards-Version: 4.7.2
Build-Depends:
 asciidoctor,
 debhelper-compat (= 13),
 dh-sequence-bash-completion,
 fakeroot,
 git,
 libcapture-tiny-perl,
 libclone-perl,
 libconfig-general-perl,
 libconfig-tiny-perl,
 libdata-validate-ip-perl,
 libdatetime-perl,
 libdbd-mysql-perl,
 libdbi-perl,
 libhash-merge-perl,
 libio-interface-perl,
 libipc-system-simple-perl,
 libmime-base64-perl,
 libnet-netmask-perl,
 libreadonly-perl,
 libregexp-ipv6-perl,
 libsocket-perl,
 libsys-hostname-long-perl,
 libtemplate-perl,
 libterm-readpassword-perl,
 libyaml-libyaml-perl,
 pkwalify,
 python3-minimal (>= 3.9~),
 python3-pytest,

Package: libngcp-template-perl
Section: perl
Architecture: all
Depends:
 libtemplate-perl,
 ${misc:Depends},
 ${perl:Depends},
Replaces:
 ngcp-ngcpcfg,
Description: NGCP subclass for Template Toolkit
 This package contains a Template subclass to be used for any NGCP template
 files, which will setup all necessary configuration options for the class,
 and inject an "ngcp" object in the variables providing NGCP-specific
 functionality to be used from within the templates.

Package: ngcp-ngcpcfg
Architecture: all
Depends:
 etckeeper,
 file,
 git (>= 1:1.7.2.5-3~),
 libcapture-tiny-perl,
 libclone-perl,
 libconfig-general-perl,
 libconfig-tiny-perl,
 libdata-validate-ip-perl,
 libdatetime-perl,
 libdbd-mysql-perl,
 libdbi-perl,
 libhash-merge-perl,
 libio-interface-perl,
 libipc-system-simple-perl,
 libmime-base64-perl,
 libnet-netmask-perl,
 libngcp-template-perl,
 libregexp-ipv6-perl,
 libsocket-perl,
 libsys-hostname-long-perl,
 libterm-readpassword-perl,
 libyaml-libyaml-perl,
 ngcp-system-tools,
 pkwalify,
 psmisc,
 ${misc:Depends},
 ${perl:Depends},
Description: central and templated based Configuration Management System for NGCP platforms
 ngcp-ngcpcfg is a Configuration Management System providing central
 configuration and template based handling of configuration
 files, featuring handling of local configuration changes and
 updates as well as synchronisation between servers.

Package: ngcp-ngcpcfg-locker
Architecture: all
Depends:
 ngcp-ngcpcfg,
 sqop,
 ${misc:Depends},
Description: Encrypt and decrypt feature for ngcp-ngcpcfg
 This package provides the encrypt and decrypt options for
 usage via ngcpcfg.

Package: ngcp-ngcpcfg-testsuite
Architecture: all
Depends:
 ngcp-ngcpcfg,
 ${misc:Depends},
Description: testsuite for ngcpcfg
 This package provides a testsuite to automatically test ngcpcfg
 features and detect any possible breakages.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

SCRIPTS = \
	$(CURDIR)/usr/sbin/ngcp-instances-validator \
	$(CURDIR)/usr/sbin/ngcp-network \
	$(CURDIR)/usr/sbin/ngcp-network-validator

%:
	dh $@

override_dh_auto_build:
	dh_testdir
	$(MAKE) man
	# catch any syntax errors *before* building the .deb
	$(MAKE) syntaxcheck

execute_after_dh_install:
	for s in $(SCRIPTS); do \
	  test -r "$$s" \
	    && sed -i -e "s/VERSION = 'UNRELEASED'/VERSION = '$(VERSION)'/" "$$s" \
	    || true; \
	done

execute_after_dh_auto_test:
	## this is a hack to automatically copy the pytest result via pbuilder to
	## the workspace so we can automatically use it as Jenkins test result
	# starting with pbuilder v0.216 it defaults to /build
	if [ -d /build/ ] ; then find $(CURDIR)/results/ -name pytest.xml -exec cp {} /build/ \; || true ; fi
	# previous pbuilder versions default to /tmp/buildd
	if [ -d /tmp/buildd/ ] ; then find $(CURDIR)/results/ -name pytest.xml -exec cp {} /tmp/buildd/ \; || true ; fi
